blob: 328cd80d83a03a674e0541bddb6bce0532c682b7 [file] [log] [blame]
しらいしななこf2c66ed2007-06-30 14:37:09 +09001#!/bin/sh
2# Copyright (c) 2007, Nanako Shiraishi
3
Stephan Beyera5ab00c2008-08-16 05:27:31 +02004dashless=$(basename "$0" | sed -e 's/-/ /')
5USAGE="list [<options>]
Stephen Boydfcdd0e92009-06-17 18:07:37 -07006 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
Stephan Beyera5ab00c2008-08-16 05:27:31 +02009 or: $dashless branch <branchname> [<stash>]
Thomas Gummerer1ada5022017-02-28 20:33:39 +000010 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
Stephan Beyera5ab00c2008-08-16 05:27:31 +020015 or: $dashless clear"
しらいしななこf2c66ed2007-06-30 14:37:09 +090016
James Bowes3cd24912007-07-06 15:57:47 -040017SUBDIRECTORY_OK=Yes
Junio C Hamano8f321a32007-11-06 01:50:02 -080018OPTIONS_SPEC=
Elia Pintod0ea45b2014-04-23 06:44:01 -070019START_DIR=$(pwd)
しらいしななこf2c66ed2007-06-30 14:37:09 +090020. git-sh-setup
21require_work_tree
Patrick Steinhardt22fc7032017-06-13 13:38:34 +020022prefix=$(git rev-parse --show-prefix) || exit 1
Junio C Hamanoceff0792007-07-25 15:32:22 -070023cd_to_toplevel
しらいしななこf2c66ed2007-06-30 14:37:09 +090024
25TMP="$GIT_DIR/.git-stash.$$"
Nguyễn Thái Ngọc Duyc697b572014-11-30 15:24:32 +070026TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
Johannes Sixt3ba2e862011-03-16 09:18:49 +010027trap 'rm -f "$TMP-"* "$TMPindex"' 0
しらいしななこf2c66ed2007-06-30 14:37:09 +090028
29ref_stash=refs/stash
30
Thomas Rastdda1f2a2009-08-13 14:29:44 +020031if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34else
35 help_color=
36 reset_color=
37fi
38
しらいしななこf2c66ed2007-06-30 14:37:09 +090039no_changes () {
Thomas Gummererdf6bba02017-02-28 20:33:38 +000040 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
David Caldwell78751302011-06-24 17:56:06 -070042 (test -z "$untracked" || test -z "$(untracked_files)")
43}
44
45untracked_files () {
Kevin Daudt5fc92f82017-08-14 23:43:33 +020046 if test "$1" = "-z"
47 then
48 shift
49 z=-z
50 else
51 z=
52 fi
David Caldwell78751302011-06-24 17:56:06 -070053 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
Kevin Daudt5fc92f82017-08-14 23:43:33 +020055 git ls-files -o $z $excl_opt -- "$@"
しらいしななこf2c66ed2007-06-30 14:37:09 +090056}
57
58clear_stash () {
Junio C Hamano3023dc62008-01-05 01:35:54 -080059 if test $# != 0
60 then
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +000061 die "$(gettext "git stash clear with parameters is unimplemented")"
Junio C Hamano3023dc62008-01-05 01:35:54 -080062 fi
David Aguilar1956dfa2014-09-15 20:24:10 -070063 if current=$(git rev-parse --verify --quiet $ref_stash)
Junio C Hamano7ab3cc72007-07-26 23:24:28 -070064 then
Emil Medvea9ee9bf2007-11-07 15:10:27 -060065 git update-ref -d $ref_stash $current
Junio C Hamano7ab3cc72007-07-26 23:24:28 -070066 fi
しらいしななこf2c66ed2007-06-30 14:37:09 +090067}
68
Junio C Hamanobc9e7392007-07-08 01:38:32 -070069create_stash () {
Thomas Gummerer9ca63262017-02-19 11:03:10 +000070 stash_msg=
71 untracked=
72 while test $# != 0
73 do
74 case "$1" in
75 -m|--message)
76 shift
77 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
78 ;;
79 -u|--include-untracked)
80 shift
81 untracked=${1?"BUG: create_stash () -u requires an argument"}
82 ;;
Thomas Gummererdf6bba02017-02-28 20:33:38 +000083 --)
84 shift
85 break
86 ;;
Thomas Gummerer9ca63262017-02-19 11:03:10 +000087 esac
88 shift
89 done
Junio C Hamano9f62e182007-07-04 22:46:09 -070090
Junio C Hamano1eff26c2008-09-04 02:41:22 -070091 git update-index -q --refresh
Thomas Gummererdf6bba02017-02-28 20:33:38 +000092 if no_changes "$@"
しらいしななこf2c66ed2007-06-30 14:37:09 +090093 then
しらいしななこf2c66ed2007-06-30 14:37:09 +090094 exit 0
95 fi
しらいしななこf12e9252007-07-28 10:44:48 +090096
しらいしななこf2c66ed2007-06-30 14:37:09 +090097 # state of the base commit
Junio C Hamano5be60072007-07-02 22:52:14 -070098 if b_commit=$(git rev-parse --verify HEAD)
しらいしななこf2c66ed2007-06-30 14:37:09 +090099 then
Jeff Kingb0e621a2010-04-08 15:42:37 -0400100 head=$(git rev-list --oneline -n 1 HEAD --)
しらいしななこf2c66ed2007-06-30 14:37:09 +0900101 else
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000102 die "$(gettext "You do not have the initial commit yet")"
しらいしななこf2c66ed2007-06-30 14:37:09 +0900103 fi
104
Junio C Hamano5be60072007-07-02 22:52:14 -0700105 if branch=$(git symbolic-ref -q HEAD)
しらいしななこf2c66ed2007-06-30 14:37:09 +0900106 then
107 branch=${branch#refs/heads/}
108 else
109 branch='(no branch)'
110 fi
111 msg=$(printf '%s: %s' "$branch" "$head")
112
113 # state of the index
Junio C Hamano5be60072007-07-02 22:52:14 -0700114 i_tree=$(git write-tree) &&
Jean-Luc Herren6143fa22007-09-12 20:45:03 +0200115 i_commit=$(printf 'index on %s\n' "$msg" |
Junio C Hamano5be60072007-07-02 22:52:14 -0700116 git commit-tree $i_tree -p $b_commit) ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000117 die "$(gettext "Cannot save the current index state")"
しらいしななこf2c66ed2007-06-30 14:37:09 +0900118
David Caldwell78751302011-06-24 17:56:06 -0700119 if test -n "$untracked"
120 then
121 # Untracked files are stored by themselves in a parentless commit, for
122 # ease of unpacking later.
123 u_commit=$(
Kevin Daudt5fc92f82017-08-14 23:43:33 +0200124 untracked_files -z "$@" | (
Elia Pintobed137d2014-05-23 03:15:31 -0700125 GIT_INDEX_FILE="$TMPindex" &&
126 export GIT_INDEX_FILE &&
David Caldwell78751302011-06-24 17:56:06 -0700127 rm -f "$TMPindex" &&
128 git update-index -z --add --remove --stdin &&
129 u_tree=$(git write-tree) &&
130 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
131 rm -f "$TMPindex"
Vasco Almeida850251f2016-09-19 13:08:21 +0000132 ) ) || die "$(gettext "Cannot save the untracked files")"
David Caldwell78751302011-06-24 17:56:06 -0700133
134 untracked_commit_option="-p $u_commit";
135 else
136 untracked_commit_option=
137 fi
138
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200139 if test -z "$patch_mode"
140 then
141
142 # state of the working tree
143 w_tree=$( (
Johannes Sixt3ba2e862011-03-16 09:18:49 +0100144 git read-tree --index-output="$TMPindex" -m $i_tree &&
145 GIT_INDEX_FILE="$TMPindex" &&
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200146 export GIT_INDEX_FILE &&
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000147 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
Jonathon Mah44df2e22011-12-30 16:14:01 -0800148 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200149 git write-tree &&
Johannes Sixt3ba2e862011-03-16 09:18:49 +0100150 rm -f "$TMPindex"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200151 ) ) ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000152 die "$(gettext "Cannot save the current worktree state")"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200153
154 else
155
Junio C Hamanob24f56d2007-07-08 01:28:18 -0700156 rm -f "$TMP-index" &&
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200157 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
158
159 # find out what the user wants
160 GIT_INDEX_FILE="$TMP-index" \
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000161 git add--interactive --patch=stash -- "$@" &&
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200162
163 # state of the working tree
164 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000165 die "$(gettext "Cannot save the current worktree state")"
しらいしななこf2c66ed2007-06-30 14:37:09 +0900166
Jonathon Mah44df2e22011-12-30 16:14:01 -0800167 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200168 test -s "$TMP-patch" ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000169 die "$(gettext "No changes selected")"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200170
171 rm -f "$TMP-index" ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000172 die "$(gettext "Cannot remove temporary index (can't happen)")"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200173
174 fi
175
しらいしななこf2c66ed2007-06-30 14:37:09 +0900176 # create the stash
Junio C Hamano9f62e182007-07-04 22:46:09 -0700177 if test -z "$stash_msg"
178 then
179 stash_msg=$(printf 'WIP on %s' "$msg")
180 else
181 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
182 fi
183 w_commit=$(printf '%s\n' "$stash_msg" |
Junio C Hamano22f41282011-07-22 14:46:28 -0700184 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185 die "$(gettext "Cannot record working tree state")"
Junio C Hamanobc9e7392007-07-08 01:38:32 -0700186}
しらいしななこf2c66ed2007-06-30 14:37:09 +0900187
Ramkumar Ramachandrabd514ca2013-06-15 18:43:25 +0530188store_stash () {
189 while test $# != 0
190 do
191 case "$1" in
192 -m|--message)
193 shift
194 stash_msg="$1"
195 ;;
196 -q|--quiet)
197 quiet=t
198 ;;
199 *)
200 break
201 ;;
202 esac
203 shift
204 done
205 test $# = 1 ||
206 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
207
208 w_commit="$1"
209 if test -z "$stash_msg"
210 then
211 stash_msg="Created via \"git stash store\"."
212 fi
213
David Turner89dea972015-07-21 17:04:56 -0400214 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
Ramkumar Ramachandrabd514ca2013-06-15 18:43:25 +0530215 ret=$?
Jeff King268ef4d2016-05-13 16:47:33 -0400216 test $ret != 0 && test -z "$quiet" &&
Ramkumar Ramachandrabd514ca2013-06-15 18:43:25 +0530217 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
218 return $ret
219}
220
Thomas Gummererf5727e22017-02-19 11:03:08 +0000221push_stash () {
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200222 keep_index=
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200223 patch_mode=
David Caldwell78751302011-06-24 17:56:06 -0700224 untracked=
Thomas Gummererf5727e22017-02-19 11:03:08 +0000225 stash_msg=
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700226 while test $# != 0
227 do
228 case "$1" in
Johannes Schindelinea41cfc2009-07-27 20:37:10 +0200229 -k|--keep-index)
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700230 keep_index=t
231 ;;
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200232 --no-keep-index)
Dan McGee3a243f72011-04-07 12:04:20 -0500233 keep_index=n
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200234 ;;
235 -p|--patch)
236 patch_mode=t
Dan McGee3a243f72011-04-07 12:04:20 -0500237 # only default to keep if we don't already have an override
238 test -z "$keep_index" && keep_index=t
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700239 ;;
240 -q|--quiet)
241 GIT_QUIET=t
242 ;;
David Caldwell78751302011-06-24 17:56:06 -0700243 -u|--include-untracked)
244 untracked=untracked
245 ;;
246 -a|--all)
247 untracked=all
248 ;;
Thomas Gummererf5727e22017-02-19 11:03:08 +0000249 -m|--message)
250 shift
251 test -z ${1+x} && usage
252 stash_msg=$1
253 ;;
Jeff King5ba28312015-05-20 14:17:46 -0400254 --help)
255 show_help
256 ;;
Matthieu Moy3c2eb802009-08-18 23:38:40 +0200257 --)
258 shift
259 break
260 ;;
261 -*)
Ævar Arnfjörð Bjarmasoneed10642011-05-21 18:44:17 +0000262 option="$1"
263 # TRANSLATORS: $option is an invalid option, like
264 # `--blah-blah'. The 7 spaces at the beginning of the
265 # second line correspond to "error: ". So you should line
266 # up the second line with however many characters the
267 # translation of "error: " takes in your language. E.g. in
268 # English this is:
269 #
270 # $ git stash save --blah-blah 2>&1 | head -n 2
271 # error: unknown option for 'stash save': --blah-blah
272 # To provide a message, use git stash save -- '--blah-blah'
Ross Lagerwalled3c4002012-04-14 14:37:29 +0200273 eval_gettextln "error: unknown option for 'stash save': \$option
274 To provide a message, use git stash save -- '\$option'"
Matthieu Moy3c2eb802009-08-18 23:38:40 +0200275 usage
276 ;;
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700277 *)
278 break
279 ;;
280 esac
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200281 shift
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700282 done
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200283
Patrick Steinhardt22fc7032017-06-13 13:38:34 +0200284 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
285
David Caldwell78751302011-06-24 17:56:06 -0700286 if test -n "$patch_mode" && test -n "$untracked"
287 then
Vasco Almeida850251f2016-09-19 13:08:21 +0000288 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
David Caldwell78751302011-06-24 17:56:06 -0700289 fi
290
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000291 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
292
Junio C Hamano1eff26c2008-09-04 02:41:22 -0700293 git update-index -q --refresh
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000294 if no_changes "$@"
Junio C Hamanobc9e7392007-07-08 01:38:32 -0700295 then
Ævar Arnfjörð Bjarmason5a175872011-05-21 18:44:12 +0000296 say "$(gettext "No local changes to save")"
Junio C Hamanobc9e7392007-07-08 01:38:32 -0700297 exit 0
298 fi
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000299
David Turner89dea972015-07-21 17:04:56 -0400300 git reflog exists $ref_stash ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000301 clear_stash || die "$(gettext "Cannot initialize stash")"
Junio C Hamanobc9e7392007-07-08 01:38:32 -0700302
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000303 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
Ramkumar Ramachandrabd514ca2013-06-15 18:43:25 +0530304 store_stash -m "$stash_msg" -q $w_commit ||
305 die "$(gettext "Cannot save the current status")"
Vasco Almeida599e7a02016-08-10 10:50:30 +0000306 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200307
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200308 if test -z "$patch_mode"
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200309 then
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000310 if test $# != 0
311 then
Thomas Gummerer1790f4f2017-03-21 22:12:17 +0000312 git reset -q -- "$@"
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000313 git ls-files -z --modified -- "$@" |
314 git checkout-index -z --force --stdin
Thomas Gummerer1790f4f2017-03-21 22:12:17 +0000315 git clean --force -q -d -- "$@"
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000316 else
Thomas Gummerer1790f4f2017-03-21 22:12:17 +0000317 git reset --hard -q
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000318 fi
David Caldwell78751302011-06-24 17:56:06 -0700319 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
320 if test -n "$untracked"
321 then
Thomas Gummererdf6bba02017-02-28 20:33:38 +0000322 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
David Caldwell78751302011-06-24 17:56:06 -0700323 fi
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200324
Jeff King268ef4d2016-05-13 16:47:33 -0400325 if test "$keep_index" = "t" && test -n "$i_tree"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200326 then
Thomas Gummerere0e7f992017-03-21 22:12:19 +0000327 git read-tree --reset $i_tree
328 git ls-files -z --modified -- "$@" |
329 git checkout-index -z --force --stdin
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200330 fi
331 else
332 git apply -R < "$TMP-patch" ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000333 die "$(gettext "Cannot remove worktree changes")"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200334
Dan McGee3a243f72011-04-07 12:04:20 -0500335 if test "$keep_index" != "t"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200336 then
Thomas Gummerer869fb8f2017-03-21 22:12:18 +0000337 git reset -q -- "$@"
Thomas Rastdda1f2a2009-08-13 14:29:44 +0200338 fi
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200339 fi
しらいしななこf2c66ed2007-06-30 14:37:09 +0900340}
341
Thomas Gummererf5727e22017-02-19 11:03:08 +0000342save_stash () {
343 push_options=
344 while test $# != 0
345 do
346 case "$1" in
347 --)
348 shift
349 break
350 ;;
351 -*)
352 # pass all options through to push_stash
353 push_options="$push_options $1"
354 ;;
355 *)
356 break
357 ;;
358 esac
359 shift
360 done
361
362 stash_msg="$*"
363
364 if test -z "$stash_msg"
365 then
366 push_stash $push_options
367 else
368 push_stash $push_options -m "$stash_msg"
369 fi
370}
371
Jeff King401de402007-07-02 00:21:24 -0400372have_stash () {
David Aguilar1956dfa2014-09-15 20:24:10 -0700373 git rev-parse --verify --quiet $ref_stash >/dev/null
Jeff King401de402007-07-02 00:21:24 -0400374}
375
しらいしななこf2c66ed2007-06-30 14:37:09 +0900376list_stash () {
Jeff King401de402007-07-02 00:21:24 -0400377 have_stash || return 0
Jeff King288c67c2014-08-06 14:35:25 -0400378 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
しらいしななこf2c66ed2007-06-30 14:37:09 +0900379}
380
381show_stash () {
Jeff Kingd6cc2df2015-05-20 14:01:32 -0400382 ALLOW_UNKNOWN_FLAGS=t
Jon Seymoura9bf09e2010-08-21 14:09:02 +1000383 assert_stash_like "$@"
Gustaf Hendeby14cd4582010-03-16 18:52:37 +0100384
Namhyung Kim3086c062015-08-30 00:25:57 +0900385 if test -z "$FLAGS"
386 then
387 if test "$(git config --bool stash.showStat || echo true)" = "true"
388 then
389 FLAGS=--stat
390 fi
391
392 if test "$(git config --bool stash.showPatch || echo false)" = "true"
393 then
394 FLAGS=${FLAGS}${FLAGS:+ }-p
395 fi
396
397 if test -z "$FLAGS"
398 then
399 return 0
400 fi
401 fi
402
403 git diff ${FLAGS} $b_commit $w_commit
しらいしななこf2c66ed2007-06-30 14:37:09 +0900404}
405
Jeff King5ba28312015-05-20 14:17:46 -0400406show_help () {
407 exec git help stash
408 exit 1
409}
410
Jon Seymouref763122010-08-21 14:46:22 +1000411#
412# Parses the remaining options looking for flags and
413# at most one revision defaulting to ${ref_stash}@{0}
414# if none found.
415#
416# Derives related tree and commit objects from the
417# revision, if one is found.
418#
419# stash records the work tree, and is a merge between the
420# base commit (first parent) and the index tree (second parent).
421#
422# REV is set to the symbolic version of the specified stash-like commit
423# IS_STASH_LIKE is non-blank if ${REV} looks like a stash
424# IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
425# s is set to the SHA1 of the stash commit
426# w_commit is set to the commit containing the working tree
427# b_commit is set to the base commit
428# i_commit is set to the commit containing the index tree
David Caldwell78751302011-06-24 17:56:06 -0700429# u_commit is set to the commit containing the untracked files tree
Jon Seymouref763122010-08-21 14:46:22 +1000430# w_tree is set to the working tree
431# b_tree is set to the base tree
432# i_tree is set to the index tree
David Caldwell78751302011-06-24 17:56:06 -0700433# u_tree is set to the untracked files tree
Jon Seymouref763122010-08-21 14:46:22 +1000434#
435# GIT_QUIET is set to t if -q is specified
436# INDEX_OPTION is set to --index if --index is specified.
Jeff Kingd6cc2df2015-05-20 14:01:32 -0400437# FLAGS is set to the remaining flags (if allowed)
Jon Seymouref763122010-08-21 14:46:22 +1000438#
439# dies if:
440# * too many revisions specified
441# * no revision is specified and there is no stash stack
442# * a revision is specified which cannot be resolve to a SHA1
443# * a non-existent stash reference is specified
Jeff Kingd6cc2df2015-05-20 14:01:32 -0400444# * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
Jon Seymouref763122010-08-21 14:46:22 +1000445#
446
447parse_flags_and_rev()
448{
449 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
450 PARSE_CACHE="$*"
451
452 IS_STASH_LIKE=
453 IS_STASH_REF=
454 INDEX_OPTION=
455 s=
456 w_commit=
457 b_commit=
458 i_commit=
David Caldwell78751302011-06-24 17:56:06 -0700459 u_commit=
Jon Seymouref763122010-08-21 14:46:22 +1000460 w_tree=
461 b_tree=
462 i_tree=
David Caldwell78751302011-06-24 17:56:06 -0700463 u_tree=
Jon Seymouref763122010-08-21 14:46:22 +1000464
Jon Seymour2bea5932010-09-28 01:32:45 +1000465 FLAGS=
Aaron M Watsona56c8f52016-10-24 19:40:13 -0400466 REV=
Brian Gernhardt9027fa92010-09-24 18:15:34 -0400467 for opt
468 do
469 case "$opt" in
Jon Seymour2bea5932010-09-28 01:32:45 +1000470 -q|--quiet)
471 GIT_QUIET=-t
Brian Gernhardt9027fa92010-09-24 18:15:34 -0400472 ;;
Jon Seymouref763122010-08-21 14:46:22 +1000473 --index)
474 INDEX_OPTION=--index
475 ;;
Jeff King5ba28312015-05-20 14:17:46 -0400476 --help)
477 show_help
478 ;;
Jon Seymour2bea5932010-09-28 01:32:45 +1000479 -*)
Jeff Kingd6cc2df2015-05-20 14:01:32 -0400480 test "$ALLOW_UNKNOWN_FLAGS" = t ||
481 die "$(eval_gettext "unknown option: \$opt")"
Jon Seymour2bea5932010-09-28 01:32:45 +1000482 FLAGS="${FLAGS}${FLAGS:+ }$opt"
Jon Seymouref763122010-08-21 14:46:22 +1000483 ;;
Aaron M Watsona56c8f52016-10-24 19:40:13 -0400484 *)
485 REV="${REV}${REV:+ }'$opt'"
486 ;;
Jon Seymouref763122010-08-21 14:46:22 +1000487 esac
Jon Seymouref763122010-08-21 14:46:22 +1000488 done
489
Øystein Walle2a07e432014-01-07 09:22:15 +0100490 eval set -- $REV
Jon Seymouref763122010-08-21 14:46:22 +1000491
492 case $# in
493 0)
Liam Beguine01db912017-06-17 18:30:50 -0400494 have_stash || die "$(gettext "No stash entries found.")"
Jon Seymouref763122010-08-21 14:46:22 +1000495 set -- ${ref_stash}@{0}
496 ;;
497 1)
498 :
499 ;;
500 *)
Ævar Arnfjörð Bjarmason33ceddc2011-05-21 18:44:14 +0000501 die "$(eval_gettext "Too many revisions specified: \$REV")"
Jon Seymouref763122010-08-21 14:46:22 +1000502 ;;
503 esac
504
Aaron M Watsona56c8f52016-10-24 19:40:13 -0400505 case "$1" in
506 *[!0-9]*)
507 :
508 ;;
509 *)
510 set -- "${ref_stash}@{$1}"
511 ;;
512 esac
513
David Aguilar1956dfa2014-09-15 20:24:10 -0700514 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
Ævar Arnfjörð Bjarmason155da742011-05-21 18:44:16 +0000515 reference="$1"
Alex Henriead5fe372014-08-30 13:56:01 -0600516 die "$(eval_gettext "\$reference is not a valid reference")"
Ævar Arnfjörð Bjarmason155da742011-05-21 18:44:16 +0000517 }
Jon Seymouref763122010-08-21 14:46:22 +1000518
David Aguilar1956dfa2014-09-15 20:24:10 -0700519 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
Øystein Walle2a07e432014-01-07 09:22:15 +0100520 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
Jon Seymouref763122010-08-21 14:46:22 +1000521 s=$1 &&
522 w_commit=$1 &&
523 b_commit=$2 &&
524 w_tree=$3 &&
525 b_tree=$4 &&
526 i_tree=$5 &&
527 IS_STASH_LIKE=t &&
528 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
529 IS_STASH_REF=t
David Caldwell78751302011-06-24 17:56:06 -0700530
David Aguilar1956dfa2014-09-15 20:24:10 -0700531 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
Øystein Walle2a07e432014-01-07 09:22:15 +0100532 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
Jon Seymouref763122010-08-21 14:46:22 +1000533}
534
535is_stash_like()
536{
537 parse_flags_and_rev "$@"
538 test -n "$IS_STASH_LIKE"
539}
540
541assert_stash_like() {
Ævar Arnfjörð Bjarmason777b6f12011-05-21 18:44:15 +0000542 is_stash_like "$@" || {
543 args="$*"
544 die "$(eval_gettext "'\$args' is not a stash-like commit")"
545 }
Jon Seymouref763122010-08-21 14:46:22 +1000546}
547
548is_stash_ref() {
549 is_stash_like "$@" && test -n "$IS_STASH_REF"
550}
551
552assert_stash_ref() {
Ævar Arnfjörð Bjarmason777b6f12011-05-21 18:44:15 +0000553 is_stash_ref "$@" || {
554 args="$*"
555 die "$(eval_gettext "'\$args' is not a stash reference")"
556 }
Jon Seymouref763122010-08-21 14:46:22 +1000557}
558
しらいしななこf2c66ed2007-06-30 14:37:09 +0900559apply_stash () {
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700560
Jon Seymour064ed102010-08-21 14:08:58 +1000561 assert_stash_like "$@"
しらいしななこf2c66ed2007-06-30 14:37:09 +0900562
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000563 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
Ori Avtalion5fd448f2009-08-11 14:12:13 +0300564
565 # current index state
566 c_tree=$(git write-tree) ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000567 die "$(gettext "Cannot apply a stash in the middle of a merge")"
Ori Avtalion5fd448f2009-08-11 14:12:13 +0300568
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700569 unstashed_index_tree=
Jon Seymour064ed102010-08-21 14:08:58 +1000570 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
SZEDER Gábor7bedebc2008-06-27 16:37:15 +0200571 test "$c_tree" != "$i_tree"
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700572 then
Shawn O. Pearce89d750b2007-10-18 21:28:43 -0400573 git diff-tree --binary $s^2^..$s^2 | git apply --cached
Johannes Schindelin150937c2007-07-02 12:14:49 +0100574 test $? -ne 0 &&
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000575 die "$(gettext "Conflicts in index. Try without --index.")"
Martin Koegler52070792009-07-22 07:30:58 +0200576 unstashed_index_tree=$(git write-tree) ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000577 die "$(gettext "Could not save index tree")"
Johannes Schindelin150937c2007-07-02 12:14:49 +0100578 git reset
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700579 fi
Johannes Schindelin150937c2007-07-02 12:14:49 +0100580
David Caldwell78751302011-06-24 17:56:06 -0700581 if test -n "$u_tree"
582 then
Michael Forney974ce802017-08-04 23:49:05 -0700583 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
David Caldwell78751302011-06-24 17:56:06 -0700584 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
585 rm -f "$TMPindex" ||
Liam Beguine01db912017-06-17 18:30:50 -0400586 die "$(gettext "Could not restore untracked files from stash entry")"
David Caldwell78751302011-06-24 17:56:06 -0700587 fi
588
しらいしななこf2c66ed2007-06-30 14:37:09 +0900589 eval "
590 GITHEAD_$w_tree='Stashed changes' &&
591 GITHEAD_$c_tree='Updated upstream' &&
592 GITHEAD_$b_tree='Version stash was based on' &&
593 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
594 "
595
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700596 if test -n "$GIT_QUIET"
597 then
Junio C Hamano69ae92b2010-10-13 11:36:36 -0700598 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700599 fi
Martin Koegler52070792009-07-22 07:30:58 +0200600 if git merge-recursive $b_tree -- $c_tree $w_tree
しらいしななこf2c66ed2007-06-30 14:37:09 +0900601 then
602 # No conflict
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700603 if test -n "$unstashed_index_tree"
604 then
605 git read-tree "$unstashed_index_tree"
Junio C Hamano83b3df72007-07-27 23:51:45 -0700606 else
607 a="$TMP-added" &&
Shawn O. Pearce89d750b2007-10-18 21:28:43 -0400608 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
Junio C Hamano83b3df72007-07-27 23:51:45 -0700609 git read-tree --reset $c_tree &&
610 git update-index --add --stdin <"$a" ||
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000611 die "$(gettext "Cannot unstage modified files")"
Junio C Hamano83b3df72007-07-27 23:51:45 -0700612 rm -f "$a"
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700613 fi
Stephen Boydfcdd0e92009-06-17 18:07:37 -0700614 squelch=
615 if test -n "$GIT_QUIET"
616 then
617 squelch='>/dev/null 2>&1'
618 fi
Piotr Krukowiecki26b59b42011-03-12 09:57:46 +0100619 (cd "$START_DIR" && eval "git status $squelch") || :
しらいしななこf2c66ed2007-06-30 14:37:09 +0900620 else
621 # Merge conflict; keep the exit status from merge-recursive
Johannes Schindelin150937c2007-07-02 12:14:49 +0100622 status=$?
Phil Hord743bf6d2012-07-10 18:52:28 -0400623 git rerere
Jon Seymour064ed102010-08-21 14:08:58 +1000624 if test -n "$INDEX_OPTION"
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700625 then
Jon Seymour6fdd50e2011-08-07 21:58:16 +1000626 gettextln "Index was not unstashed." >&2
Junio C Hamanocbeaccc2007-07-27 23:41:31 -0700627 fi
Johannes Schindelin150937c2007-07-02 12:14:49 +0100628 exit $status
しらいしななこf2c66ed2007-06-30 14:37:09 +0900629 fi
630}
631
Jon Seymourf2768722010-08-21 14:09:00 +1000632pop_stash() {
633 assert_stash_ref "$@"
634
Junio C Hamano2d4c9932014-02-26 14:18:54 -0800635 if apply_stash "$@"
636 then
637 drop_stash "$@"
638 else
639 status=$?
Liam Beguine01db912017-06-17 18:30:50 -0400640 say "$(gettext "The stash entry is kept in case you need it again.")"
Junio C Hamano2d4c9932014-02-26 14:18:54 -0800641 exit $status
642 fi
Jon Seymourf2768722010-08-21 14:09:00 +1000643}
644
Brandon Caseye25d5f92008-02-22 13:04:54 -0600645drop_stash () {
Jon Seymour92e39e42010-08-21 14:08:59 +1000646 assert_stash_ref "$@"
Brandon Caseye25d5f92008-02-22 13:04:54 -0600647
Jon Seymour92e39e42010-08-21 14:08:59 +1000648 git reflog delete --updateref --rewrite "${REV}" &&
Ævar Arnfjörð Bjarmasond4ca6c82011-05-21 18:44:18 +0000649 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
650 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
Brandon Caseye25d5f92008-02-22 13:04:54 -0600651
652 # clear_stash if we just dropped the last stash entry
David Aguilar1956dfa2014-09-15 20:24:10 -0700653 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
654 clear_stash
Brandon Caseye25d5f92008-02-22 13:04:54 -0600655}
656
Abhijit Menon-Sen656b5032008-07-03 11:46:05 +0530657apply_to_branch () {
Ævar Arnfjörð Bjarmasonb1440ce2011-05-21 18:44:13 +0000658 test -n "$1" || die "$(gettext "No branch name specified")"
Abhijit Menon-Sen656b5032008-07-03 11:46:05 +0530659 branch=$1
Jon Seymourfb433dc2010-08-21 14:09:01 +1000660 shift 1
Abhijit Menon-Sen656b5032008-07-03 11:46:05 +0530661
Jon Seymourfb433dc2010-08-21 14:09:01 +1000662 set -- --index "$@"
663 assert_stash_like "$@"
Abhijit Menon-Sen656b5032008-07-03 11:46:05 +0530664
Jon Seymourfb433dc2010-08-21 14:09:01 +1000665 git checkout -b $branch $REV^ &&
Jon Seymour57693d02010-09-28 23:19:52 +1000666 apply_stash "$@" && {
667 test -z "$IS_STASH_REF" || drop_stash "$@"
668 }
Abhijit Menon-Sen656b5032008-07-03 11:46:05 +0530669}
670
Thomas Gummerer9e140902017-02-28 20:33:40 +0000671test "$1" = "-p" && set "push" "$@"
672
Jon Seymouref763122010-08-21 14:46:22 +1000673PARSE_CACHE='--not-parsed'
Thomas Gummerer1ada5022017-02-28 20:33:39 +0000674# The default command is "push" if nothing but options are given
Matthieu Moy3c2eb802009-08-18 23:38:40 +0200675seen_non_option=
676for opt
677do
678 case "$opt" in
Thomas Gummerer9e140902017-02-28 20:33:40 +0000679 --) break ;;
Matthieu Moy3c2eb802009-08-18 23:38:40 +0200680 -*) ;;
681 *) seen_non_option=t; break ;;
682 esac
683done
684
Thomas Gummerer1ada5022017-02-28 20:33:39 +0000685test -n "$seen_non_option" || set "push" "$@"
Matthieu Moy3c2eb802009-08-18 23:38:40 +0200686
しらいしななこf2c66ed2007-06-30 14:37:09 +0900687# Main command set
688case "$1" in
Junio C Hamanofcb10a92007-07-02 23:15:45 -0700689list)
690 shift
しらいしななこf2c66ed2007-06-30 14:37:09 +0900691 list_stash "$@"
692 ;;
693show)
694 shift
695 show_stash "$@"
696 ;;
Kevin Leung683befa2007-12-03 10:34:05 +0800697save)
698 shift
Junio C Hamano47629dc2008-07-23 13:33:44 -0700699 save_stash "$@"
Kevin Leung683befa2007-12-03 10:34:05 +0800700 ;;
Thomas Gummererf5727e22017-02-19 11:03:08 +0000701push)
702 shift
703 push_stash "$@"
704 ;;
しらいしななこf2c66ed2007-06-30 14:37:09 +0900705apply)
706 shift
707 apply_stash "$@"
708 ;;
709clear)
Junio C Hamano3023dc62008-01-05 01:35:54 -0800710 shift
711 clear_stash "$@"
しらいしななこf2c66ed2007-06-30 14:37:09 +0900712 ;;
Junio C Hamanobc9e7392007-07-08 01:38:32 -0700713create)
Ramkumar Ramachandra0719f302013-06-15 18:43:24 +0530714 shift
Thomas Gummerer9ca63262017-02-19 11:03:10 +0000715 create_stash -m "$*" && echo "$w_commit"
Junio C Hamanobc9e7392007-07-08 01:38:32 -0700716 ;;
Ramkumar Ramachandrabd514ca2013-06-15 18:43:25 +0530717store)
718 shift
719 store_stash "$@"
720 ;;
Brandon Caseye25d5f92008-02-22 13:04:54 -0600721drop)
722 shift
723 drop_stash "$@"
724 ;;
Brandon Caseybd56ff52008-02-22 16:52:50 -0600725pop)
726 shift
Jon Seymourf2768722010-08-21 14:09:00 +1000727 pop_stash "$@"
Brandon Caseybd56ff52008-02-22 16:52:50 -0600728 ;;
Abhijit Menon-Sen656b5032008-07-03 11:46:05 +0530729branch)
730 shift
731 apply_to_branch "$@"
732 ;;
しらいしななこf2c66ed2007-06-30 14:37:09 +0900733*)
Matthieu Moy3c2eb802009-08-18 23:38:40 +0200734 case $# in
735 0)
Thomas Gummerer1ada5022017-02-28 20:33:39 +0000736 push_stash &&
Ævar Arnfjörð Bjarmason5a175872011-05-21 18:44:12 +0000737 say "$(gettext "(To restore them type \"git stash apply\")")"
Johannes Schindelinea41cfc2009-07-27 20:37:10 +0200738 ;;
739 *)
Kevin Leung683befa2007-12-03 10:34:05 +0800740 usage
Johannes Schindelinea41cfc2009-07-27 20:37:10 +0200741 esac
Junio C Hamano9f62e182007-07-04 22:46:09 -0700742 ;;
しらいしななこf2c66ed2007-06-30 14:37:09 +0900743esac